/*
##############################################################
   REGULATOR TZU
##############################################################   
   
   (c) Ivo Strasil, Materna EGMedical 2011
   www.strasil.net
   ivo@strasil.net
   
   Tento zdrojovy kod ani s jeho pomoci vytvoreni program 
   NENI volne siritelnym!
##############################################################


*/

// enkoder
// gnd - cerna
// vcc - cervena
// A - bl
// B - zelen

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <util/delay.h>
#include <util/atomic.h>

#include "leddisplay.h"
#include "main.h"

//volatile uint8_t f200hz; // priznak pro enkoder a displej
// volatile uint16_t frek; // frekvence v Hz
volatile uint16_t rychlost; // aktualni rychlost posuvu v mm
volatile uint16_t frychlost; // filtrovana aktualni rychlost
volatile uint16_t poz_rychlost=400; // pozadovana rychlost
volatile uint64_t delka; // celkova odvinuta delka
volatile uint8_t reg=0; // regulace: 0 - rucni, 1 - automaticka
volatile uint64_t kroku=0; // pocet kroku


uint8_t EEMEM e_reg=0;
uint16_t EEMEM e_poz_rychlost=0;


volatile uint8_t predani=0;

volatile uint16_t krok_mot=0; // pri nule je vypnuto

volatile int8_t enc=0;

#define MAX_RYCHLOST 500 // 5 cm/s


// obsluha enkoderu
int8_t readEnc() {

	static uint8_t lENC0=0; // minule hodnoty
	uint8_t inc=0;

	uint8_t pom;
	
	pom = C_CHECKBIT(ENC0);

	// zvyseni hodnoty tocenim doprava
	if (pom && lENC0==0) { 
		if (C_CHECKBIT(ENC1)) {
			inc = 1;	
		} else {
			inc = -1;
		}

	}


	lENC0 = pom;
	

	return inc;
	
}

// preteceni citace (<5 Hz)
ISR(TIMER1_OVF_vect) {
	if (!predani) {
	rychlost = 0;
	predani=2;
	}
	
}

// 250 Hz, cteni enkoderu, regulator
/*ISR(TIMER2_COMP_vect) {

	static uint16_t rych_int=0,poc=0;

 	// ovladaci enkoder
	enc = readEnc();

	// regulator




}*/



volatile unsigned int poc = 0;


#define POMALY	0
#define RYCHLY	1

volatile unsigned int perioda = 0x0145;
volatile unsigned int pertmp = 0x0145;

ISR(TIMER0_COMP_vect) {
	//compare na TIMER0
	static unsigned char stav = POMALY;
	static unsigned char ocpom = 0x10;
	

	stav = !stav;

	if (stav==POMALY) {
		//pomaly, vystup pujde do 1

		//a co vypnuti motoru?		
		SFIOR|=(1<<0); //reset preddelicky
		TCCR0 = (1<<WGM01)|(0<<WGM00)|(1<<COM01)|(1<<COM00)|(1<<CS02)|(0<<CS01)|(1<<CS00);	
		SFIOR|=(1<<0); //reset preddelicky
		TCNT0 = 0;	//reset citani - zbavime se fales. pulsu				
		
		//OCR0 = (pertmp>>4)+0x04;
		//ocpom = ((((pertmp&0x0F)))) + 0x2A;

		OCR0 = (pertmp>>7)+0x03;
		ocpom = ((((pertmp&0x7F)))) + 0x30;

		pertmp = perioda;
		

	} else {
		//rychly, vystup pujde do 0
	
	//	TCCR0 = (1<<WGM01)|(0<<WGM00)|(1<<COM01)|(0<<COM00)|(0<<CS02)|(1<<CS01)|(1<<CS00);
		TCNT0 = 0;
		SFIOR|=(1<<0); //reset preddelicky
		TCCR0 = (1<<WGM01)|(0<<WGM00)|(1<<COM01)|(0<<COM00)|(0<<CS02)|(1<<CS01)|(0<<CS00);
		SFIOR|=(1<<0); //reset preddelicky				
		OCR0 = ocpom;
		

		
	}
	

}

// ovladani krok motoru, f=62.5 kHz
ISR(TIMER0_OVF_vect) {

	
}


volatile unsigned int ICRpred;

// input capture - jeden krok enkoderu
// ftc1 = 250.000 Hz
// enkoder 1.000 impulzu na otacku
// obvod kolecka 20 cm

ISR(TIMER1_CAPT_vect) {
	unsigned int pom = ICR1;
	sei();	


	TCNT1 -= pom;
	kroku++;

	if (!predani) {
		ICRpred = pom;
		// prepocet periody na rychlost
		//rychlost = (uint16_t)(500000 / (uint32_t)ICR1);
		predani=1;

	}
	
}


static uint32_t tkm=0; // rychlost prepoctena pro krok_mot

uint32_t sp = 0;


// nastaveni otacek 
// reseni rampy
void set_speed() {

	static uint32_t nsp=0; // rychlost pro rampu (mm)
	
	//nastaveni hodnoty pozadavku
	

	// zmena rychlosti - spustit prepocet
	if (sp!=nsp) {


		// rampa
		unsigned char i=40;
		while (--i) {
			if (nsp<sp) nsp++;
			if (nsp>sp) nsp--;
		}

		if (nsp!=0) {
			if (nsp>100000) nsp = 100000;
			if (nsp<20) nsp = 20;

			tkm = (uint32_t)(2000000) / nsp;

			//min. rychlost motoru
			if (tkm>(uint32_t)30000) tkm = 30000;

			if (tkm<20) tkm = 20;

			// prepis hodnoty 
			ATOMIC_BLOCK(ATOMIC_FORCEON) { perioda = tkm;}

		} else {			
			nsp = 0;
			tkm = 0; // stop motoru
			ATOMIC_BLOCK(ATOMIC_FORCEON) { perioda = 30000;}			
		}


	}

	

	
}

void init(void) {

	DDRA=0b11111111;
	PORTA=0x00;

	 DDRB=0b11111110;
	 PORTB=0x01;
 
	 DDRD=0b10110000;
	 PORTD=0xFF;
 
	 DDRC=0xFF;
	 PORTC=0x00;

	// TC1 -> mereni rychlosti posuvu
	// normal mode, fosc/64
	TCCR1B = (0<<CS12)|(1<<CS11)|(1<<CS10)|(0<<WGM12)|(1<<ICNC1)|(0<<ICES1);
	

	// TC0 -> generovani frekvence pro driver krokoveho motoru
	// normal mode, presc 1, f=62.5
//	TCCR0 = (0<<WGM01)|(0<<WGM00)|(0<<COM01)|(0<<COM00)|(0<<CS02)|(0<<CS01)|(1<<CS00);




	// Timer/Counter 0 initialization
	// Clock source: System Clock
	// Clock value: 62,500 kHz
	// Mode: CTC top=OCR0
	// OC0 output: Toggle on compare match
	//TCCR0=0x1A;
	TCCR0 = (1<<WGM01)|(0<<WGM00)|(1<<COM01)|(1<<COM00)|(1<<CS02)|(0<<CS01)|(1<<CS00);	
	TCNT0=0x00;
	OCR0=0x70;




	// tc2, CTC - cteni enkoderu, regulator?, 250 Hz
	TCCR2 = (1<<WGM21)|(0<<WGM20)|(0<<COM21)|(0<<COM20)|(1<<CS22)|(0<<CS21)|(1<<CS20);
	OCR2 = 249;

	// povoleni preruseni
	TIMSK = (1<<TICIE1)|(1<<TOIE1)/*|(1<<TOIE0)|(1<<OCIE0)*//*|(0<<OCIE2)*/;


  
	 //dame 250ms na ustaleni napeti...
	 _delay_ms(250); 

	// obnova nastaveni z EEPROM
	reg = eeprom_read_byte(&e_reg);
	poz_rychlost = eeprom_read_word(&e_poz_rychlost);


 
	 sei();
 
 
	 ledtext[0]='0';
	 ledtext[1]='0';
	 ledtext[2]='0';
	 ledtext[3]='0';
	 ledtext[4]='0';
 
	 LedSetDotPos(3);

//	 leds |= 4; // indikace napajeni


}

static int32_t zasah=0;


// vraci akcni zasah
uint32_t regulator(uint16_t akt, uint16_t poz) {

	static char zpomal = 0;
	

	int16_t err; // chyba regulace

	


	//return 300;

	zpomal++;
	//zpomal=0;

	if (poz!=0) { // regulujeme

		//return 50;

		err = (int16_t)poz - (int16_t)akt; // odchylka

		unsigned char dodmax;
		if (poz<150) dodmax=128-16; else dodmax=12;

		if (zpomal % 2 == 0) {

			if (err>0) {
				unsigned char dod;
				
				if (err<20) dod = dodmax; else dod=0;

				unsigned int chci;

				//chci=(poz-akt)/10+(zpomal%8==0)?1:0;
				
				if (poz<150) chci=((poz-akt)/32)*1 + ((zpomal%(16+dod))==0)?1:0;
				else chci=((poz-akt)/128)*4 /*128*/ + (((zpomal%(4+dod))==0)?1:0);
						
				if (chci>20) chci=20;
				if (zasah<100000) zasah+=chci; //omez. max. rychlosti
		
			} // err >0

			if (err<0) {
				unsigned char dod;
				if (err>-20) dod = dodmax; else dod=0;
				
				unsigned int chci;
				
				//chci=(akt-poz)/10+(zpomal%8==0)?1:0;

				if (poz<150) chci=((akt-poz)/32)*1 + ((zpomal%(16+dod))==0)?1:0;
				else chci=((akt-poz)/128)*4 + (((zpomal%(4+dod))==0)?1:0);			

				if (chci>20) chci=20;
				if (chci>zasah) zasah = 0; else zasah-=chci;

			} // err < 0

		} // if zpomal

		
		 // pri malych rychlostech vzdycky neco vratit
		//if (poz>100 && zasah<50) return 50;
		//else
		
		return (uint32_t)zasah;
		


	} else { // reset regulatoru a zastaveni
	
		//sum = 0;
		zasah = 0;
		return 0;
	
	}

}


// pamat. nast rychlost, navoleny rezim (autom./rucni reg.)
// 4. dioda - chyba regulace < 5%

int main(void) {

	
	
	uint16_t dis=0;
	uint32_t lastfr2=0;
	uint16_t ddelay=0; // zpomaleni zobrazeni
	uint16_t encpp=0; // delka stisknuti enkoderu
	uint8_t tecka=3; // pozice tecky
	uint8_t startp=0, stopp=0; // delka stisknuti start, stop

	#define MED_LEN 20
	uint16_t med_arr[MED_LEN]; // pole pro median
	uint8_t med_idx=0;

	enum {AKT,/*SUM,*/ POZ,DELKA};

	uint8_t mode = AKT;
	uint8_t chod = 0;

	uint8_t byloPredani = 0;

unsigned long frychlostpom=0;
unsigned char frpcnt = 0;
unsigned long frfiltrovana=0;

unsigned long ICRsum=0;
unsigned int ICRsumCnt=0;
unsigned int frychlost2=0;
volatile unsigned int ICRpred2=0;

	unsigned long prp = 0;

	for (uint8_t i=0; i<MED_LEN; i++)
		med_arr[i]=0;

	
	init(); // inicializace
 


	unsigned int loopcnt = 0;

	unsigned char FRFILTRnew=5;


	sp=0; //zastavit motor
	prp = 60;

	C_CLEARBIT(MOT_ENA);


	while(1) {

		// cteni ovladaciho enkoderu
		enc = readEnc();


		if (chod) {
		
			C_SETBIT(MOT_ENA);
			TIMSK|=(1<<OCIE0)|(1<<TOIE0);

			// zapnuta automaticka regulace
			if (reg) {
		
				uint16_t err;

				if (poz_rychlost>frychlost) err = poz_rychlost - frychlost;
				else err = frychlost - poz_rychlost;

				if (err>=(4)) {
					loopcnt++;
					
						//sp = (regulator(frychlost,poz_rychlost));		

				

					
					if (  
					
					(!(loopcnt&255) && (err>=10)) ||
					(!(loopcnt&1023))
					) {

						if (frychlost<poz_rychlost) {														
								if (prp<700) prp+=(1+(err/50)); 
							} else {			
								if (prp>30) prp-=(1+(err/50));
							}

						sp = prp*prp/15;
					}
				}


				if (poz_rychlost>frfiltrovana) err = poz_rychlost - frfiltrovana;
				else err = frfiltrovana - poz_rychlost;

				
				
				if (err<=(poz_rychlost/40)) {
					leds |= 1; // chyba <5% rozsvitit led1					
				}

				if (err>=(poz_rychlost/15)) {
					leds &= ~1; // zhasnout led1
				}

			} else {
				
				sp = (poz_rychlost)*((poz_rychlost/15)+1);//(unsigned long)(poz_rychlost);//*(unsigned long)350;

				leds &= ~1; // zhasnout led1

			}
		
				
				
		
		} else {
		
			C_CLEARBIT(MOT_ENA);

			TIMSK&=~((1<<OCIE0)|(1<<TOIE0));

			//			(regulator(0,0)); // reset regulatoru
			sp=0; //zastavit motor
			prp = 60;
		
		}


		set_speed();

		// obsluha tlacitka start
		if (!C_CHECKBIT(START) ) {
		
			if (startp<255) { 

				if (startp>20) { // min delka stisku
					
					chod = 1;
					startp=255; // spec hodnota
					
					
				} else startp++;
				
			}
		
		} else startp=0;

		
		// obsluha tlacitka stop
		if (!C_CHECKBIT(STOP) ) {
		
			if (stopp<255) { 

				if (stopp>20) { // min delka stisku
					
					if (chod==1) chod=0;
					else {
					
						reg ^= 1;
						eeprom_write_byte(&e_reg,reg);						
						
					}

					stopp=255; // spec hodnota
					
					
				} else stopp++;
				
			}
		
		} else stopp=0;


		// obsluha ledek
		if (chod) leds |= 8;
			else leds &= ~8;

		if (reg) leds |= 2;
			else leds &= ~2;


		



		byloPredani = 0;


		if (predani==1) {

						
			rychlost = (uint16_t)(500000 / (uint32_t)ICRpred);
			ICRpred2 = ICRpred;

			predani = 0;
			if (rychlost<900) {
				byloPredani = 1;
			}
		
		}	
		
		if (predani==2) {
		
			rychlost = 0;

			predani = 0;
			byloPredani = 2;
			ICRsum=0;
			ICRsumCnt=0;
		}	

		if (byloPredani) {
			if (byloPredani==2) {
				//frychlost = 0;
				frychlost2 = 0;
				byloPredani = 4;
			}

#define SUMCNT	1

			if (byloPredani==1){
				ICRsum+=(unsigned long)ICRpred2;
				ICRsumCnt++;
				if (ICRsumCnt==SUMCNT) {

					

					frychlost2 = (unsigned long)SUMCNT*(unsigned long)500000/(unsigned long)ICRsum;

					
					//odfiltrujeme rychle zmeny a uplne mimo rozsah...
					
					if (frychlost2<1500 && frychlost2+10>lastfr2 && lastfr2+10>frychlost2)
						byloPredani = 4;


					lastfr2 = frychlost2;
					

					ICRsum=0;
					ICRsumCnt = 0;
				}
			}

			
			if(byloPredani==4) {
				//if (rychlost>4000) rychlost = 4000;
			
				LedOff();

				// filtrovani medianem
				med_arr[med_idx] = frychlost2;
				if (++med_idx==MED_LEN) med_idx=0;

					for(uint8_t y=0; y<MED_LEN-1; y++) {	
						if(med_arr[y]>med_arr[y+1]) {	
							uint16_t temp = med_arr[y+1];
							med_arr[y+1] = med_arr[y];
							med_arr[y] = temp;					
						} // if 
					} // for 

				
				//vzit 1+2+1 stredni hodnoty

				unsigned long l=0;
				for (unsigned char i=0;i<2;i++) 
					l+=med_arr[MED_LEN/2+i]+med_arr[MED_LEN/2-i];

								
				frychlost = l/4;

				frychlostpom+=frychlost;				


				if (++frpcnt>FRFILTRnew || (frychlost<25)) {					
					frfiltrovana = frychlostpom / (frpcnt);
					frpcnt = 0;
					frychlostpom = 0;
					FRFILTRnew = 1 + (frfiltrovana/3);
					if (FRFILTRnew > 100) FRFILTRnew = 100;
				}

			}



		}

		// obsluha ovladaciho enkoderu
		#define DLOUHY 9000
				
		if (!C_CHECKBIT(ENCP) ) { // enkoder stisknuty
		
			if (encpp<65000) encpp++;

			if (encpp>=DLOUHY && mode==DELKA) { // dlouhy stisk
				
				ATOMIC_BLOCK(ATOMIC_FORCEON) {kroku = 0;} // vynulovani delky
					
			}

		
		} else {

			if (encpp>0) { // byl stisk

				
				if (encpp>50 && encpp<DLOUHY) { // kratky stisk
					
					// zaloha poz. rychlosti
					if (mode==POZ) eeprom_write_word(&e_poz_rychlost,poz_rychlost);

					// prepnuti menu
					if (++mode>DELKA) mode = AKT;
				}

				encpp =0;
					
			}
		
		}
	

		if (mode==POZ || (mode==AKT && !reg)) {

				int8_t z;

				
				z = enc*5;
				enc = 0;


				if (((int16_t)poz_rychlost+z)>0)
					poz_rychlost = (uint16_t)((int16_t)poz_rychlost + (int16_t)z);
				if (poz_rychlost>MAX_RYCHLOST) poz_rychlost = MAX_RYCHLOST;


	 			poz_rychlost = poz_rychlost/5 * 5;

				if (poz_rychlost<10) poz_rychlost = 10;

		}

		// obsluha zvoleneho modu
		switch (mode) {
		
			case AKT: {
			
				ledtext[0]='A';
				tecka = 2;


				dis = (frfiltrovana+2)/5*5;


				//dis = perioda;
			} break;

/*			case SUM: {
			
				ledtext[0]='n';
				tecka = 0;
				
				//dis = 1234;
				dis = zasah;
				


			} break;*/

			case POZ: {

				//static uint16_t min_poz_rychlost=0;
			
				ledtext[0]='P';
				tecka = 2;
				dis = poz_rychlost;


			} break;
			case DELKA: {

				ledtext[0]='d';
				tecka = 2;
				
				
				dis = delka;
				//dis = prp;
				//dis = frychlost2;
				
			
			} break;
		
		
		 
		
		} // switch


		// zmena obsahu displeje
		if (++ddelay==250) {

			LedDispNumber(dis,1);
			LedSetDotPos(tecka);
			ddelay=0;

			// vypocet odvinute delky 
			// 1.000 kroku = 20 cm

			unsigned long long pizda;

			ATOMIC_BLOCK(ATOMIC_FORCEON) { pizda=kroku;}
			delka = (pizda + 25) / 50;

		}


		

		
			LedMux();
		
		//_delay_ms(15);
		_delay_us(300);

	}

	

}
