/*
##############################################################
   REGULATOR TZU
##############################################################   
   
   (c) Ivo Strasil, Materna EGMedical 2011
   www.strasil.net
   ivo@strasil.net
   
   Tento zdrojovy kod ani s jeho pomoci vytvoreni program 
   NENI volne siritelnym!
##############################################################


*/

// enkoder
// gnd - cerna
// vcc - cervena
// A - bl
// B - zelen

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <util/delay.h>
#include <util/atomic.h>

#include "leddisplay.h"
#include "main.h"

//volatile uint8_t f200hz; // priznak pro enkoder a displej
// volatile uint16_t frek; // frekvence v Hz
volatile uint16_t rychlost; // aktualni rychlost posuvu v mm
volatile uint16_t frychlost; // filtrovana aktualni rychlost
volatile uint16_t poz_rychlost=400; // pozadovana rychlost
volatile uint64_t delka; // celkova odvinuta delka
volatile uint8_t reg=0; // regulace: 0 - rucni, 1 - automaticka
volatile uint64_t kroku=0; // pocet kroku


uint8_t EEMEM e_reg=0;
uint16_t EEMEM e_poz_rychlost=0;


volatile uint8_t predani=0;

volatile uint16_t krok_mot=0; // pri nule je vypnuto

volatile int8_t enc=0;

#define MAX_RYCHLOST 500 // 5 cm/s


// obsluha enkoderu
int8_t readEnc() {

	static uint8_t lENC0=0,lENC1=0; // minule hodnoty
	uint8_t inc=0;

	// zvyseni hodnoty tocenim doprava
	if (C_CHECKBIT(ENC0) && lENC0==0 && C_CHECKBIT(ENC1)) { 
	
		inc = 1;	

	}

	// snizeni hodnoty tocenim doleva
	if (C_CHECKBIT(ENC1) && lENC1==0 && C_CHECKBIT(ENC0)) {
	
		inc = -1;	

	}


	lENC0 = C_CHECKBIT(ENC0);
	lENC1 = C_CHECKBIT(ENC1);

	return inc;
	
}

// preteceni citace (<5 Hz)
ISR(TIMER1_OVF_vect) {
	if (!predani) {
	rychlost = 0;
	predani=2;
	}
	
}

// 250 Hz, cteni enkoderu, regulator
/*ISR(TIMER2_COMP_vect) {

	static uint16_t rych_int=0,poc=0;

 	// ovladaci enkoder
	enc = readEnc();

	// regulator




}*/



volatile unsigned int poc = 0;


#define POMALY	0
#define RYCHLY	1

volatile unsigned int perioda = 0x0145;
volatile unsigned int pertmp = 0x0145;

ISR(TIMER0_COMP_vect) {
	//compare na TIMER0
	static unsigned char stav = POMALY;
	

	stav = !stav;

	if (stav==POMALY) {
		//pomaly, vystup pujde do 1
		TCNT0 = 0;	//reset citani - zbavime se fales. pulsu

		//set on match
		TCCR0 = (1<<WGM01)|(0<<WGM00)|(1<<COM01)|(1<<COM00)|(1<<CS02)|(0<<CS01)|(1<<CS00);
		pertmp = perioda;
		OCR0 = 0xF0;

	} else {

		//rychly, vystup pujde do 0		
		//clear on match
		TCCR0 = (1<<WGM01)|(0<<WGM00)|(1<<COM01)|(0<<COM00)|(1<<CS02)|(0<<CS01)|(1<<CS00);
		TCNT0 = 0;
		OCR0 = 0xF0;		

	}
	

}

// ovladani krok motoru, f=62.5 kHz
ISR(TIMER0_OVF_vect) {

	volatile unsigned int krok_mot_int=1000;

//	TCNT0+=100;
/*

	if ((++poc&0xF0) == 0)  {
		C_SETBIT(MOT_PULS);
		//krok_mot_int = 1000;
		//poc=0;
	} else {
		C_CLEARBIT(MOT_PULS);
	}

*/

/*
	if (poc >= 100 && krok_mot!=0) {
		C_SETBIT(MOT_PULS);
		
		//krok_mot_int = 100;
		poc = 0;
	} else {
		C_CLEARBIT(MOT_PULS);
	}
*/	
	poc++;



	
	

	
}


volatile unsigned int ICRpred;

// input capture - jeden krok enkoderu
// ftc1 = 250.000 Hz
// enkoder 1.000 impulzu na otacku
// obvod kolecka 20 cm
ISR(TIMER1_CAPT_vect) {

	TCNT1 -= ICR1;

	kroku++;

	if (!predani) {
		ICRpred = ICR1;
		// prepocet periody na rychlost
		//rychlost = (uint16_t)(500000 / (uint32_t)ICR1);
		predani=1;

	}
	
}


static uint32_t tkm=0; // rychlost prepoctena pro krok_mot

uint32_t sp = 0;


// nastaveni otacek 
// reseni rampy
void set_speed() {

	static uint32_t nsp=0; // rychlost pro rampu (mm)
	


	//nastaveni hodnoty pozadavku
	

	// zmena rychlosti - spustit prepocet
	if (sp!=nsp) {


		// rampa
		unsigned char i=20;
		while (--i) {
			if (nsp<sp) nsp++;
			if (nsp>sp) nsp--;
		}

		if (sp!=0) tkm = (42000*64*10) / nsp;
		else {			
			nsp = 0;
			tkm = 0; // stop motoru
			ATOMIC_BLOCK(ATOMIC_FORCEON) { perioda = 0x0145;}			
		}

		//min. rychlost motoru
		if (tkm>4090) tkm = 4090;

		if (tkm<0x010) tkm = 0x010;

		// prepis hodnoty 
		ATOMIC_BLOCK(ATOMIC_FORCEON) { perioda = nsp/5;}

	}

	

	
}

void init(void) {

	DDRA=0b11111111;
	PORTA=0x00;

	DDRB=0b11111110;
	PORTB=0x01;
 
	DDRD=0b10110000;
	PORTD=0xFF;
 
	DDRC=0xFF;
	PORTC=0x00;

	// TC1 -> mereni rychlosti posuvu
	// normal mode, fosc/64
	TCCR1B = (0<<CS12)|(1<<CS11)|(1<<CS10)|(0<<WGM12)|(1<<ICNC1)|(0<<ICES1);
	

	// TC0 -> generovani frekvence pro driver krokoveho motoru
	// normal mode, presc 1, f=62.5
	OCR0 = 0xA0;

	TCCR0 = (1<<WGM01)|(0<<WGM00)|(0<<COM01)|(1<<COM00)|(1<<CS02)|(0<<CS01)|(1<<CS00);


	// Timer/Counter 0 initialization
	// Clock source: System Clock
	// Clock value: 62,500 kHz
	// Mode: CTC top=OCR0
	// OC0 output: Toggle on compare match
	//TCCR0=0x1A;
	//TCCR0=0x1C;
	TCNT0=0x00;
	//OCR0=0x70;




	// tc2, CTC - cteni enkoderu, regulator?, 250 Hz
	TCCR2 = (1<<WGM21)|(0<<WGM20)|(0<<COM21)|(0<<COM20)|(1<<CS22)|(0<<CS21)|(1<<CS20);
	OCR2 = 249;

	// povoleni preruseni
	TIMSK = /*(1<<TICIE1)|(1<<TOIE1)*//*|(1<<TOIE0)|(1<<OCIE0)*//*|(0<<OCIE2)*/0;


  
	 //dame 250ms na ustaleni napeti...
	 _delay_ms(250); 

	// obnova nastaveni z EEPROM
	reg = eeprom_read_byte(&e_reg);
	poz_rychlost = eeprom_read_word(&e_poz_rychlost);


 
	sei();
 
 
	ledtext[0]='0';
	ledtext[1]='0';
	ledtext[2]='0';
	ledtext[3]='0';
	ledtext[4]='0';
 
	LedSetDotPos(3);

	leds |= 4; // indikace napajeni
}

static int32_t zasah=0;


// vraci akcni zasah
uint32_t regulator(uint16_t akt, uint16_t poz) {

	static char zpomal = 0;
	

	int16_t err; // chyba regulace

	


	//return 300;

	zpomal++;
	//zpomal=0;

	if (poz!=0) { // regulujeme

		//return 50;

		err = (int16_t)poz - (int16_t)akt; // odchylka

		unsigned char dodmax;
		if (poz<150) dodmax=128-16; else dodmax=12;

		if (zpomal % 2 == 0) {

			if (err>0) {
				unsigned char dod;
				
				if (err<20) dod = dodmax; else dod=0;

				unsigned int chci;

				//chci=(poz-akt)/10+(zpomal%8==0)?1:0;
				
				if (poz<150) chci=((poz-akt)/32)*1 + ((zpomal%(16+dod))==0)?1:0;
				else chci=((poz-akt)/128)*4 /*128*/ + (((zpomal%(4+dod))==0)?1:0);
						
				if (chci>20) chci=20;
				if (zasah<100000) zasah+=chci; //omez. max. rychlosti
		
			} // err >0

			if (err<0) {
				unsigned char dod;
				if (err>-20) dod = dodmax; else dod=0;
				
				unsigned int chci;
				
				//chci=(akt-poz)/10+(zpomal%8==0)?1:0;

				if (poz<150) chci=((akt-poz)/32)*1 + ((zpomal%(16+dod))==0)?1:0;
				else chci=((akt-poz)/128)*4 + (((zpomal%(4+dod))==0)?1:0);			

				if (chci>20) chci=20;
				if (chci>zasah) zasah = 0; else zasah-=chci;

			} // err < 0

		} // if zpomal

		
		 // pri malych rychlostech vzdycky neco vratit
		//if (poz>100 && zasah<50) return 50;
		//else
		
		return (uint32_t)zasah;
		


	} else { // reset regulatoru a zastaveni
	
		//sum = 0;
		zasah = 0;
		return 0;
	
	}

}


// pamat. nast rychlost, navoleny rezim (autom./rucni reg.)
// 4. dioda - chyba regulace < 5%

int main(void) {

	
	
	uint16_t dis=0;
	uint32_t sum=0;
	uint32_t filtr=0;
	uint16_t filtrout=0;
	uint8_t idx=0;
	uint16_t ddelay=0; // zpomaleni zobrazeni
	uint16_t encpp=0; // delka stisknuti enkoderu
	uint8_t tecka=3; // pozice tecky
	uint32_t frychlosttmp=0;
	uint8_t startp=0, stopp=0; // delka stisknuti start, stop

	#define MED_LEN 40
	uint16_t med_arr[MED_LEN]; // pole pro median
	uint8_t med_idx=0;

	enum {AKT,SUM, POZ,DELKA};

	uint8_t mode = AKT;
	uint8_t chod = 0;

	uint8_t byloPredani = 0;


unsigned long ICRsum=0;
unsigned int ICRsumCnt=0;
unsigned int frychlost2=0;
volatile unsigned int ICRpred2=0;


	for (uint8_t i=0; i<MED_LEN; i++)
		med_arr[i]=0;

	
	init(); // inicializace
 

 	unsigned char locknext = 0;	//blokovani pocitani po zmrsenem pulsu

	unsigned char loopcnt = 0;


	while(1) {

		// cteni ovladaciho enkoderu
		enc = readEnc();


		if (chod) {
		
			C_SETBIT(MOT_ENA);

			// zapnuta automaticka regulace
			if (reg) {
			
				

				uint16_t err;

				if (poz_rychlost>frychlost) err = poz_rychlost - frychlost;
				else err = frychlost - poz_rychlost;

				if (err>=(poz_rychlost/50)) {
					loopcnt++;
					//if (!(loopcnt&3))
						sp = (regulator(frychlost,poz_rychlost));		
				}
				
				if (err<=(poz_rychlost/20)) {
					leds |= 1; // chyba <5% rozsvitit led1
					
				}
				else leds &= ~1; // zhasnout led1


			} else sp = (unsigned long)(poz_rychlost)/**(unsigned long)350*/;
			
		
		} else {
		
			C_CLEARBIT(MOT_ENA);

			(regulator(0,0)); // reset regulatoru
			sp=0; //zastavit motor
		
		}


		set_speed();

		// obsluha tlacitka start
		if (!C_CHECKBIT(START) ) {
		
			if (startp<255) { 

				if (startp>20) { // min delka stisku
					
					chod = 1;
					startp=255; // spec hodnota
					
					
				} else startp++;
				
			}
		
		} else startp=0;

		
		// obsluha tlacitka stop
		if (!C_CHECKBIT(STOP) ) {
		
			if (stopp<255) { 

				if (stopp>20) { // min delka stisku
					
					if (chod==1) chod=0;
					else {
					
						reg ^= 1;
						eeprom_write_byte(&e_reg,reg);						
						
					}

					stopp=255; // spec hodnota
					
					
				} else stopp++;
				
			}
		
		} else stopp=0;


		// obsluha ledek
		if (chod) leds |= 8;
			else leds &= ~8;

		if (reg) leds |= 2;
			else leds &= ~2;


		



		// predani input capture a vypocet rychlosti
		/*if (predani) {

			uint16_t tmp = ICRpred;
			uint8_t tpredani = predani;

			predani=0;
			
			// rychlost nula - preteceni ct, vynulovat rychlost (fakt?)
			if (tpredani==2) {
			
				/*for (uint8_t i=0; i<AVRLEN; i++)
					avr[i]=0;

				filtr=2*filtr/3;*/

				//rychlost = 0;

		//	}

			// rychlost != 0
			//if (tpredani==1) {
			
			//	rychlost = (uint16_t)(500000 / (uint32_t)tmp);


				//if (rychlost>4000) rychlost = 9999;

		//	} else rychlost = 0;

			/*if (rychlost!=9999 && !locknext) {

				avr[idx++] = rychlost;

				if (idx==AVRLEN) idx=0;
				sum = 0;
				for (uint8_t i=0; i<AVRLEN; i++)
					sum += avr[i];

				
				filtr = rychlost + (19*filtr/20);
				filtrout = filtr / 20;


				uint16_t fr = /*sum / AVRLEN / 2 + *///filtrout /*/ 2*/;		

				//hledej median
				

				//frychlost = fr; // filtrovana rychlost*/
		//	} else {
			//	if (rychlost==9999) locknext = 1; else locknext = 0;
		//	}
			
	//	}

		byloPredani = 0;


		if (predani==1) {

						
			rychlost = (uint16_t)(500000 / (uint32_t)ICRpred);
			ICRpred2 = ICRpred;

			predani = 0;
			if (rychlost<900) {
				byloPredani = 1;
			}
		
		}	
		
		if (predani==2) {
		
			rychlost = 0;

			predani = 0;
			byloPredani = 2;
			ICRsum=0;
			ICRsumCnt=0;
		}	

		if (byloPredani) {
			if (byloPredani==2) {
				//frychlost = 0;
				frychlost2 = 0;
				byloPredani = 4;
			}

#define SUMCNT	1

			if (byloPredani==1){
				ICRsum+=(unsigned long)ICRpred2;
				ICRsumCnt++;
				if (ICRsumCnt==SUMCNT) {
					frychlost2 = (unsigned long)SUMCNT*(unsigned long)500000/(unsigned long)ICRsum;
					byloPredani = 4;
					ICRsum=0;
					ICRsumCnt = 0;
				}
			}

			
			if(byloPredani==4) {
				//if (rychlost>4000) rychlost = 4000;
			
				LedOff();

				// filtrovani medianem
				med_arr[med_idx] = frychlost2;
				if (++med_idx==MED_LEN) med_idx=0;

			/*	for(uint8_t x=0; x<MED_LEN; x++) {
					unsigned char delta = 0;*/
					for(uint8_t y=0; y<MED_LEN-1; y++) {

					if(med_arr[y]>med_arr[y+1]) {

						uint16_t temp = med_arr[y+1];

						med_arr[y+1] = med_arr[y];

						med_arr[y] = temp;
					//	delta = 1;

						} // if 

					} // for 2

				/*	if (!delta) break;
				} // for 2
*/
				//vzit 10 strednich hodnot

				unsigned long l=0;
				for (unsigned char i=0;i<2;i++) 
					l+=med_arr[MED_LEN/2+i]+med_arr[MED_LEN/2-i];

				

				//frychlost = (med_arr[MED_LEN/2] + med_arr[MED_LEN/2+1])/2;
				frychlost = l/4;

				}



		}

		// obsluha ovladaciho enkoderu
		#define DLOUHY 5000
				
		if (!C_CHECKBIT(ENCP) ) { // enkoder stisknuty
		
			if (encpp<65000) encpp++;

			if (encpp>=DLOUHY && mode==DELKA) { // dlouhy stisk
				
				ATOMIC_BLOCK(ATOMIC_FORCEON) {kroku = 0;} // vynulovani delky
					
			}

		
		} else {

			if (encpp>0) { // byl stisk

				
				if (encpp>50 && encpp<DLOUHY) { // kratky stisk
					
					// zaloha poz. rychlosti
					if (mode==POZ) eeprom_write_word(&e_poz_rychlost,poz_rychlost);

					// prepnuti menu
					if (++mode>DELKA) mode = AKT;
				}

				encpp =0;
					
			}
		
		}
	

		// obsluha zvoleneho modu
		switch (mode) {
		
			case AKT: {
			
				ledtext[0]='A';
				tecka = 2;
				//dis = frychlost;
				dis = perioda;
				


			} break;

			case SUM: {
			
				ledtext[0]='n';
				tecka = 0;
				
				dis = 1234;
				//dis = zasah;
				


			} break;

			case POZ: {

				//static uint16_t min_poz_rychlost=0;
			
				ledtext[0]='P';
				tecka = 2;

				int8_t z;

				
				z = enc*5;
				enc = 0;


				if (((int16_t)poz_rychlost+z)>0)
					poz_rychlost = (uint16_t)((int16_t)poz_rychlost + (int16_t)z);
				if (poz_rychlost>MAX_RYCHLOST) poz_rychlost = MAX_RYCHLOST;


				poz_rychlost = poz_rychlost/5 * 5;

				if (poz_rychlost<40) poz_rychlost = 40;

				dis = poz_rychlost;


			} break;
			case DELKA: {

				ledtext[0]='d';
				tecka = 2;
				dis = delka;
			
				
			
			} break;
		
		
		
		
		} // switch


		// zmena obsahu displeje
		if (++ddelay==250) {

			LedDispNumber(dis,1);
			LedSetDotPos(tecka);
			ddelay=0;

			// vypocet odvinute delky 
			// 1.000 kroku = 20 cm

			unsigned long long pizda;

			ATOMIC_BLOCK(ATOMIC_FORCEON) { pizda=kroku;}
			delka = (pizda + 25) / 50;

		}

		
		LedMux();
		


		_delay_ms(1);


		//_delay_us(100);

	}

	

}
